﻿var mainlink="https://restapi20190624033927.azurewebsites.net/api"; //core part of the webservice link 
var codestring="?code=7XMT2o8rqHbaViy2geq9X4rYFwI5xYnNav1bGFcchdlBhKXR5PvcDA=="	//webservice code, append to end of link
var blog_id = document.getElementById("storage").getAttribute("data-variable-two"); //get blog_name
var signal_type_id = document.getElementById("storage").getAttribute("data-variable-three"); //get SignalTypeId
var node_id = document.getElementById("storage").getAttribute("data-variable-four"); //get NodeId

const url = mainlink+"/ESZVerbrauchsuebersicht/"+blog_id+"/";
const url3 = mainlink+"/Massnahmen/"+blog_id+codestring;

var interval = 5; // 1:Tag(15min), 2:Tag(1h), 3:Woche(7T), 4:Monat, 5:Jahr
var periode = 0;

let dropdown = $('#datas');
var messung = document.getElementById('messung');
dropdown.empty();
dropdown.append('<option selected="true" disabled>MASSNAHME:</option>');
// Populate dropdown with list of nodes:
if (parseInt(node_id) < 0) {
$.getJSON(url3, function (data3) {
  $.each(data3, function (key, entry) {
    dropdown.append($('<option></option>').attr('value', entry.Massnahme).text(entry.Bezeichnung));
  })
})  
node_id = "1";



}
else {
$.getJSON(url3, function (data3) {
  $.each(data3, function (key, entry) {
	if (entry.Messstelle == node_id) {
    		dropdown.append($('<option></option>').attr('value', entry.Messstelle).text(entry.Bezeichnung));
		messung.text = entry.Bezeichnung;
	}
  })

})  
//dropdown.style.visibility = 'hidden';



};
//dropdown.prop('selectedIndex', parseInt(node_id));
dropdown.prop('selectedIndex', 1);

var chart = AmCharts.makeChart("chartdiv", {
  "type": "serial",
  language: "de",  
  "dataLoader": {
    "url": url+node_id+"/"+interval.toString()+"/0"+codestring,
                "format": "json",
                "showErrors": true
  },
  "valueAxes": [{
    "gridColor": "#FFFFFF",
    "gridAlpha": 0.2,
    "dashLength": 0,
"title": "Einsparung (kWh)"

  }],
  "gridAboveGraphs": true,
  "startDuration": 1,
  "graphs": [{
    "balloonText": "[[category]]: <b>[[value]]</b>",
    "fillAlphas": 0.8,
    "lineAlpha": 0.2,
    "type": "column",
    "valueField": "value"
  }],
  "chartCursor": {
    "categoryBalloonEnabled": false,
    "cursorAlpha": 0,
//    "categoryBalloonDateFormat":  "DD.MM.YYYY HH:NN:SS",
    "zoomable": false
  },
  "categoryField": "date",
  "categoryAxis": {
    "gridPosition": "start",
    "gridAlpha": 0,
    "tickPosition": "start",
    "tickLength": 20,
      "parseDates": true,
    "autoGuides": {
      "days": [ 0, 6 ],
     "tickLength": 1,      
      "lineColor": "#000",
      "lineAlpha": 0,
      "fillColor": "#000",
      "fillAlpha": 0.02  
    }    
  },
    colors: ["#3b7695", "#6a8da7", "#85c1e6", "#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"],

    "dataDateFormat": "YYYY-MM-DDTJJ:NN:SS",
    "export": {
        "enabled": true,
        "exportSelection": true,
        "dateFormat": "DD.MM.YYYY HH:NN:SS"
    }
});

//chart.colors = ["#3b7695", "#6a8da7", "#85c1e6", "#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];

setMinPeriod();

function loadDataSetData() {
  var SelectedIndex = document.getElementById("datas").selectedIndex;

  if (SelectedIndex == 0) chart.colors = ["#3b7695", "#6a8da7", "#85c1e6", "#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];
  else if (SelectedIndex == 1) chart.colors = ["#6a8da7", "#85c1e6", "#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];
  else if (SelectedIndex == 2) chart.colors = ["#85c1e6", "#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];
  else if (SelectedIndex == 3) chart.colors = ["#86b39e", "#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];
  else if (SelectedIndex == 4) chart.colors = ["#c7d9ce", "#a59669", "#2A0CD0", "#333333", "#990000"];
  else if (SelectedIndex == 3) chart.colors = ["#a59669", "#2A0CD0", "#333333", "#990000"];
  
  var dataset_url = url + document.getElementById("datas").options[document.getElementById("datas").selectedIndex].value;
  dataset_url = dataset_url + "/" + interval.toString() + "/" + periode.toString() + codestring;

  AmCharts.loadFile(dataset_url, {}, function(data) {
    chart.dataProvider = AmCharts.parseJSON(data);
    chart.validateData();
  });
  
  setMinPeriod();
}

function setMinPeriod() {
  var btnInt1 = document.getElementById("btnInt1");
  var btnInt2 = document.getElementById("btnInt2");
  var btnInt3 = document.getElementById("btnInt3");
  var btnInt4 = document.getElementById("btnInt4");
  var btnInt5 = document.getElementById("btnInt5");
  var btnZurueck = document.getElementById("btnZurueck");
  var btnVor = document.getElementById("btnVor");

  btnInt1.style.backgroundColor = "#cccccc"; 
  btnInt2.style.backgroundColor = "#cccccc"; 
  btnInt3.style.backgroundColor = "#cccccc"; 
  btnInt4.style.backgroundColor = "#cccccc"; 
  btnInt5.style.backgroundColor = "#cccccc"; 

  btnInt1.style.color = "#000000"; 
  btnInt2.style.color = "#000000"; 
  btnInt3.style.color = "#000000"; 
  btnInt4.style.color = "#000000"; 
  btnInt5.style.color = "#000000"; 
 
  var categoryAxis = chart.categoryAxis;
  categoryAxis.parseDates = true;
  if (interval == 1) {
    categoryAxis.minPeriod = "15mm"; 
    btnInt1.style.backgroundColor = "#33809e"; 
    btnInt1.style.color = "#ffffff"; 
    btnZurueck.textContent = "Tag zurück"; 
    btnVor.textContent = "Tag vorwärts"; 
  }
  else if (interval == 2) {
    categoryAxis.minPeriod = "hh"; 
    btnInt2.style.backgroundColor = "#33809e"; 
    btnInt2.style.color = "#ffffff"; 
    btnZurueck.textContent = "Tag zurück"; 
    btnVor.textContent = "Tag vorwärts"; 
  }
  else if (interval == 3) { 
    categoryAxis.minPeriod = "DD"; 
    btnInt3.style.backgroundColor = "#33809e"; 
    btnInt3.style.color = "#ffffff"; 
    btnZurueck.textContent = "Woche zurück"; 
    btnVor.textContent = "Woche vorwärts"; 
  }
  else if (interval == 4) {
    categoryAxis.minPeriod = "DD";
    btnInt4.style.backgroundColor = "#33809e"; 
    btnInt4.style.color = "#ffffff"; 
    btnZurueck.textContent = "Monat zurück"; 
    btnVor.textContent = "Monat vorwärts"; 
  }
  else if (interval == 5) {
    categoryAxis.minPeriod = "MM"; 
    btnInt5.style.backgroundColor = "#33809e"; 
    btnInt5.style.color = "#ffffff"; 
    btnZurueck.textContent = "Jahr zurück"; 
    btnVor.textContent = "Jahr vorwärts"; 
  }
}

function SetIntervall(nIntervall) {
  interval = nIntervall; 
  loadDataSetData();
}

function PeriodeZurueck() {
  var btnVor = document.getElementById("btnVor");
  var maxPeriod = 0;
  
  if (interval == 1) maxPeriod = 230;
  else if (interval == 2) maxPeriod = 230;
  else if (interval == 3) maxPeriod = 36;
  else if (interval == 4) maxPeriod = 28;
  else if (interval == 5) maxPeriod = 1;

  if (periode < maxPeriod) {
    periode++; 
    loadDataSetData();
  }
  loadDataSetData();
  btnVor.style.backgroundColor = "#33809e"; 
}

function PeriodeVorwaerts() {
  var btnVor = document.getElementById("btnVor");
  if (periode > 0) {
    periode--;
    loadDataSetData();
  }
  else {
    btnVor.style.backgroundColor = "#cccccc"; 
  }
}